Attribute VB_Name = "AUTOTOMO"
'  Copyright (c) 2003 Intelligent Resources Inc. All rights reserved.
'  An image map and a contour map are created for VELOIT10.GRD. Both maps
'  are then combined into one map via Map|Overlay Maps.
'  Also, a second image map is created for COVERG10.GRD.

Option Explicit

Dim SurferApp As Object
Dim convertInchToCentimeter As Boolean
Dim TomoDoc As Object
Dim TomoWindow As Object
Dim CoverageDoc As Object
Dim CoverageWindow As Object

Dim TomoMapFrame As Object
Dim TomoMap As Object
Dim ColorMap As Object
Dim ColorScale As Object

Dim ContourMapFrame As Object
Dim ContourMap As Object
Dim ContourLevels As Object
Dim ContourLevel As Object
Dim LevelLine As Object

Dim ShotPostMapFrame As Object
Dim ShotPostMap As Object

Dim OverlayMapFrame As Object

Dim CoverageMapFrame As Object
Dim CoverageMap As Object

Dim BaseMapFrame As Object
Dim BaseMap As Object

Dim retValue As Boolean
Dim isRayTrial As Boolean
Dim isSrfTrial As Boolean
Dim useOwnNumberFormatting As Boolean
Dim postShotPoints As Boolean
Dim labelShotPoints As Boolean
Dim postReceivers As Boolean
Dim labelReceivers As Boolean
Dim GSCenteredFont As Boolean
Dim PlotTitle As String
Dim debugScript As Boolean

Dim userPlotLimits As Boolean
Dim minX As Double
Dim maxX As Double
Dim minY As Double
Dim maxY As Double
Dim trunc_minZ As Integer
Dim trunc_maxZ As Integer
Dim maxZ_Contour As Integer
Dim zContour_Interval As Integer
Dim proportionalXYScaling As Boolean
Dim xScaleLength As Double
Dim yScaleLength As Double
Dim adaptColorScale As Boolean
Dim colorScaleHeight As Double
Dim scaleVeloInterval As Integer
Dim scaleCoverageInterval As Integer

Dim TomoGrid As String
Dim TomoSrfFile As String
Dim gotCoverageGrid As Boolean
Dim CoverageGrid As String
Dim CoverageSrfFile As String
Dim End_FlagFile As String
Dim Rayfract_AppTitle As String
Dim ShotDataFile As String
Dim isConstVelocity As Boolean
Dim contourGrid As Boolean
Dim boreholeSurvey As Boolean
Dim horizontalHole As Boolean
Dim verticalPlotTitle As Boolean
Dim plotOverburdenRefractor As Boolean
Dim plotBaseRefractor As Boolean
Dim plotRefractors As Boolean
Dim plotTomogram As Boolean
Dim plotTopography As Boolean
Dim plotDepth As Boolean
Dim plotVelocity As Boolean
Dim plotInFeet As Boolean
Dim CSVInFeet As Boolean
Dim CSVInMeters As Boolean
Dim yTopCoord As Double

Dim gotLayerPlotFile As Boolean
Dim LayerPlot_FileName As String
Dim gotLayerModelFile As Boolean
Dim LayerModel_FileName As String
Dim LayerBLN_FileName As String
Dim layerModelLines As Integer
Dim layerModelTitle As String
Dim minPlot_layer As Integer
Dim maxPlot_layer As Integer
Dim layer1_color As String
Dim layer2_color As String

Sub Read_StringParam_From_ParFile ( stringRead As String )

    Dim parLine As String
    Dim pathStart As Integer

    Line Input #1, parLine

    pathStart = InStr(parLine, ": ") + 2
    stringRead = Mid(parLine, pathStart)

End Sub

Sub Read_DoubleParam_From_ParFile ( doubleRead As Double )

    Dim parLine As String
    Dim valueStart As Integer

    Line Input #1, parLine
    valueStart = InStrRev(parLine, " ") + 1
    parLine = Mid(parLine, valueStart)
    doubleRead = Val(parLine)

End Sub

Sub Read_Optional_DoubleParam_From_ParFile ( lineTag As String, _
    doubleRead As Double )

    Dim parLine As String
    Dim valueStart As Integer
    Dim filePos As Long

    filePos = Seek(1)
    Line Input #1, parLine

    If InStr(parLine, lineTag) Then
        valueStart = InStrRev(parLine, " ") + 1
        parLine = Mid(parLine, valueStart)
        doubleRead = Val(parLine)
    Else
        doubleRead = 0.0
        Seek #1, filePos
    End If

End Sub

Sub Read_IntParam_From_ParFile ( intRead As Integer )

    Dim value As Double

    Read_DoubleParam_From_ParFile(value)

    intRead = value
End Sub

Sub Read_Optional_IntParam_From_ParFile ( lineTag As String, _
    intRead As Integer )

    Dim value As Double

    Read_Optional_DoubleParam_From_ParFile lineTag, value

    intRead = value
End Sub

Sub Read_Boolean_From_ParFile( boolRead As Boolean)
    Dim boolFlag As Integer

    Read_IntParam_From_ParFile(boolFlag)
    boolRead = ( boolFlag = 1 )
End Sub

Sub Read_Optional_Boolean_From_ParFile( lineTag As String, _
    boolRead As Boolean)

    Dim boolFlag As Integer

    Read_Optional_IntParam_From_ParFile lineTag, boolFlag
    boolRead = ( boolFlag = 1 )
End Sub

Sub Init_Flags_From_ParFile

    Read_Boolean_From_ParFile(isConstVelocity)
    contourGrid = Not isConstVelocity
    Read_Boolean_From_ParFile(boreholeSurvey)
    Read_Boolean_From_ParFile(isRayTrial)

    Debug.Print "Is constant velocity   : "; isConstVelocity
    Debug.Print "Contour grid data      : "; contourGrid
    Debug.Print "Is borehole survey     : "; boreholeSurvey
    Debug.Print "isRayTrial             : "; isRayTrial
    Debug.Print ""

End Sub

Sub Init_XYZ_Range_And_ZContour_And_ScaleLengths_From_ParFile

    Read_Boolean_From_ParFile(userPlotLimits)
    Read_DoubleParam_From_ParFile(minX)
    Read_DoubleParam_From_ParFile(maxX)
    Read_DoubleParam_From_ParFile(minY)
    Read_DoubleParam_From_ParFile(maxY)
    Read_IntParam_From_ParFile(trunc_minZ)
    Read_IntParam_From_ParFile(trunc_maxZ)

    Read_IntParam_From_ParFile(zContour_Interval)
    Read_Boolean_From_ParFile(proportionalXYScaling)
    Read_DoubleParam_From_ParFile(xScaleLength)
    Read_DoubleParam_From_ParFile(yScaleLength)

    Read_Boolean_From_ParFile(adaptColorScale)
    Read_DoubleParam_From_ParFile(colorScaleHeight)
    Read_IntParam_From_ParFile(scaleVeloInterval)
    Read_IntParam_From_ParFile(scaleCoverageInterval)

    Debug.Print "User plot limits   : "; userPlotLimits
    Debug.Print "minimum offset     : "; minX
    Debug.Print "maximum offset     : "; maxX
    Debug.Print "minimum elevation  : "; minY
    Debug.Print "maximum elevation  : "; maxY
    Debug.Print "truncated min. Z   : "; trunc_minZ
    Debug.Print "truncated max. Z   : "; trunc_maxZ
    Debug.Print "Z contour interval : "; zContour_Interval
    Debug.Print "Proportional XY scaling : "; proportionalXYScaling
    Debug.Print "X scale length [in]: "; xScaleLength
    Debug.Print "Y Scale length [in]: "; yScaleLength
    Debug.Print "Adapt color scale  : "; adaptColorScale
    Debug.Print "Scale height [in]  : "; colorScaleHeight
    Debug.Print "Velocity interval  : "; scaleVeloInterval
    Debug.Print "Coverage interval  : "; scaleCoverageInterval

End Sub

Sub Init_ShotPointPosting_From_ParFile

    Read_Boolean_From_ParFile(postShotPoints)
    Read_Boolean_From_ParFile(labelShotPoints)
    Read_Boolean_From_ParFile(postReceivers)
    Read_Boolean_From_ParFile(labelReceivers)
    Read_Optional_Boolean_From_ParFile "GS CENTERED font", GSCenteredFont

    Debug.Print "Post shot points : "; postShotPoints
    Debug.Print "Label shot points : "; labelShotPoints
    Debug.Print "Post receiver stations : "; postReceivers
    Debug.Print "Label receiver stations : "; labelReceivers
    Debug.Print "GS CENTERED font : "; GSCenteredFont

End Sub

Sub DebugPrint_PlotConfiguration

    Debug.Print "Plot title      : "; PlotTitle
    Debug.Print "Horizontal hole : "; horizontalHole
    Debug.Print "Vertical title  : "; verticalPlotTitle
    Debug.Print "Layer plot file : "; LayerPlot_FileName
    Debug.Print "got layer file  : "; gotLayerPlotFile
    Debug.Print "Plot topography : "; plotTopography
    Debug.Print "Plot overburden : "; plotOverburdenRefractor
    Debug.Print "Plot base refr. : "; plotBaseRefractor
    Debug.Print "Plot tomogram   : "; plotTomogram
    Debug.Print "Plot depth      : "; plotDepth
    Debug.Print "Plot velocity   : "; plotVelocity
    Debug.Print "Plot in feet    : "; plotInFeet
    Debug.Print

End Sub

Sub Reset_PlotFlags_ForVelocitySection_OrDepthSection
    If gotLayerPlotFile And ( plotVelocity Or plotDepth ) Then
        plotRefractors = True
        plotTopography = True ' layer 0 velocity, weathering velocity
        plotOverburdenRefractor = True
        plotBaseRefractor = True
        plotTomogram = False
    End If
End Sub

Sub Init_PlotConfiguration_From_ParFile

    Read_StringParam_From_ParFile(PlotTitle)

    Read_Boolean_From_ParFile(horizontalHole)
    Read_Boolean_From_ParFile(verticalPlotTitle)

    Read_StringParam_From_ParFile(LayerPlot_FileName)
    GotDiskFile LayerPlot_FileName, gotLayerPlotFile

    Read_Boolean_From_ParFile(plotTopography)
    Read_Boolean_From_ParFile(plotOverburdenRefractor)
    Read_Boolean_From_ParFile(plotBaseRefractor)

    Read_Boolean_From_ParFile(plotTomogram)
    plotDepth = Not plotTomogram

    Read_Boolean_From_ParFile(plotVelocity)
    Read_Boolean_From_ParFile(plotInFeet)

    Reset_PlotFlags_ForVelocitySection_OrDepthSection

    DebugPrint_PlotConfiguration

End Sub

Sub GotDiskFile ( diskFileName As String, _
    gotFile As Boolean )

    Dim fileOnDisk As String
    fileOnDisk = Dir$(diskFileName)
    gotFile = ( Len(fileOnDisk) > 0 )

End Sub


Sub Init_CoverageGrid_From_ParFile

    Read_StringParam_From_ParFile(CoverageGrid)
    Debug.Print "Coverage Grid : "; CoverageGrid

    GotDiskFile CoverageGrid, gotCoverageGrid
    Debug.Print "Got Coverage Grid : "; gotCoverageGrid

End Sub

Sub Init_Vars_From_ParFile

    If debugScript Then
        Open "D:\RAY\DAT\AUTOTOMO.PAR" For Input As #1
    Else
        Open "AUTOTOMO.PAR" For Input As #1
    End If

    Read_StringParam_From_ParFile(Rayfract_AppTitle)

    Init_Flags_From_ParFile

    Read_StringParam_From_ParFile(TomoGrid)
    Debug.Print "TomoGrid : "; TomoGrid

    Init_CoverageGrid_From_ParFile

    Init_XYZ_Range_And_ZContour_And_ScaleLengths_From_ParFile

    Init_ShotPointPosting_From_ParFile

    Init_PlotConfiguration_From_ParFile

    Close #1

End Sub

Sub Open_LayerPlot_File
    Open LayerPlot_FileName For Input As #1
End Sub

Sub Init_Vars_From_LayerPlotFile

    Open_LayerPlot_File

    Read_StringParam_From_ParFile(LayerModel_FileName)

    Read_IntParam_From_ParFile(minPlot_layer)

    Read_IntParam_From_ParFile(maxPlot_layer)

    Read_StringParam_From_ParFile(layer1_color)

    Read_StringParam_From_ParFile(layer2_color)

    Close #1

    GotDiskFile LayerModel_FileName, gotLayerModelFile

    plotOverburdenRefractor = plotOverburdenRefractor And gotLayerModelFile
    plotBaseRefractor = plotBaseRefractor And gotLayerModelFile
    plotRefractors = plotTopography Or plotOverburdenRefractor Or plotBaseRefractor

    Debug.Print "got layer model       : "; gotLayerModelFile
    Debug.Print "plot refractors       : "; plotRefractors
    Debug.Print "plot overburden refr. : "; plotOverburdenRefractor
    Debug.Print "plot basement refr.   : "; plotBaseRefractor
    Debug.Print "Layer model file      : "; LayerModel_FileName
    Debug.Print "Min. plot layer       : "; minPlot_layer
    Debug.Print "Max. plot layer       : "; maxPlot_layer
    Debug.Print "Layer 1 color         : "; layer1_color
    Debug.Print "Layer 2 color         : "; layer2_color
    Debug.Print ""

End Sub

Sub Init_SrfFileName_From_Grid( gridFileName As String, _
    srfFileName As String, _
    setup_End_FlagFile As Boolean )

    Dim extensionStart As Integer
    Dim directoryEnd As Integer

    extensionStart = InStrRev(gridFileName, ".")
    srfFileName = Left(gridFileName, extensionStart) + "SRF"

    Debug.Print "Surfer .GRD file : "; gridFileName
    Debug.Print "Surfer .SRF file : "; srfFileName

    If setup_End_FlagFile Then
        End_FlagFile = Left(gridFileName, extensionStart) + "OK"
        Debug.Print "End_FlagFile : "; End_FlagFile
    End If

    directoryEnd = InStrRev(gridFileName, "\")
    ShotDataFile = Left(gridFileName, directoryEnd) + "SHOTMAP.TXT"
    Debug.Print "ShotDataFile : "; ShotDataFile
    Debug.Print ""

End Sub

Sub Init_Global_Vars

    useOwnNumberFormatting = True
    ' SetLocale &H409 ' English, US. Copied from Scripter 11 help.
    ' use own DoubleToString formatting routine, disregard current locale
    isSrfTrial = True

    contourGrid = True
    boreholeSurvey = False
    horizontalHole = False
    verticalPlotTitle = false ' boreholeSurvey And Not horizontalHole

    Debug.Print ""
    Debug.Print "Please wait a few seconds, for Surfer..."

End Sub

Sub Check_Surfer_Version
    Dim demoString_Start As Integer
    Dim caption As String
    Dim version As String

    caption = SurferApp.Caption
    demoString_Start = InStr(caption, "Demo")
    isSrfTrial = demoString_Start > 0

    Debug.Print "Surfer main window title : "; caption
    Debug.Print "Surfer application name : "; SurferApp.Name
    Debug.Print "Surfer version : "; SurferApp.Version
    Debug.Print "isSrfTrial : "; isSrfTrial

    version = "Surfer version nr. is " + SurferApp.Version

    If Not debugScript Then
        Open "AUTOTOMO.RUN" For Output As #2
        Write #2, version
        Close #2
    End If
End Sub

Sub Create_Document_And_Window ( document As Object, _
    window As Object )

    Set document = SurferApp.Documents.Add
    Set window = document.Windows(1)

    window.AutoRedraw = False
End Sub

Sub Determine_YTopCoord
    If Not boreholeSurvey Then
        yTopCoord = maxY
        If labelShotPoints And Not userPlotLimits Then
            yTopCoord = maxY + (maxY - minY)/20.0
        End If
    Else
        yTopCoord = maxY
    End If
End Sub

Sub Setup_MapFrame_Limits_And_Scale ( frame As Object )
    'Setup Limits tab, for map: don't blank out shot labels !
    Determine_YTopCoord

    frame.SetLimits(minX, maxX, minY, yTopCoord)
    If proportionalXYScaling Then
        'Leave default scale and size; works fine
        'frame.xLength = 4
        'frame.yMapPerPU = frame.xMapPerPU
    Else
        Dim xLength As Double
        xLength = 6
        Dim yLength As Double
        yLength = 4
        If userPlotLimits Then
            xLength = xScaleLength
            yLength = yScaleLength
        End If
        Convert_Inch_To_Centimeter xLength
        frame.xLength = xLength

        Convert_Inch_To_Centimeter yLength
        frame.yLength = yLength
    End If    'Setup Scale tab, for map
End Sub

Sub Setup_ColorMap ( imageMap As Object, _
    adaptDataLimits As Boolean )

    Set ColorMap = imageMap.ColorMap

    Dim oldSurfer As Boolean
    oldSurfer = ( InStr(SurferApp.Version, "8.") = 1 )
    oldSurfer = oldSurfer Or ( InStr(SurferApp.Version, "7.") = 1 )
    If ( oldSurfer ) Then
        ColorMap.LoadFile(SurferApp.Path+"\samples\rainbow2.clr")
    Else
        ColorMap.LoadFile(SurferApp.Path+"\colorscales\rainbow2.clr")
    End If

    If adaptDataLimits Then
        ColorMap.SetDataLimits(DataMin:=trunc_minZ, DataMax:=trunc_maxZ)
    End If

End Sub

Sub Setup_ColorScale ( imageMap As Object, isVelocityPlot As Boolean )

    If adaptColorScale Then
        Set ColorScale = imageMap.ColorScale
        Dim height As Double
        height = colorScaleHeight
        Convert_Inch_To_Centimeter height
        ColorScale.Height = height
        If ( isVelocityPlot ) Then
            ColorScale.LabelInterval = scaleVeloInterval
        Else
            ColorScale.LabelInterval = scaleCoverageInterval
        End If
    End If

End Sub

Sub Count_Commas_In_LineBuffer ( parLine As String, _
    commaCount As Integer )

    commaCount = 0
    Dim commaIndex As Integer

    commaIndex = InStr(parLine, ",")
    While commaIndex > 0
        commaCount = commaCount + 1
        parLine = Mid$(parLine, commaIndex+1)
        commaIndex = InStr(parLine, ",")
    Wend
End Sub

Sub Convert_Meter_To_Feet ( value As Double )
    value = value / 0.3048
End Sub

Sub Convert_Feet_To_Meter ( value As Double )
    value = value * 0.3048
End Sub

Sub Convert_Refractor_To_Feet_Or_Meters ( _
    offset As Double, _
    topo As Double, _
    topo1 As Double, _
    topo2 As Double )

    'match distance unit specified in .PAR file for selected .GRD file
    If plotInFeet And CSVInMeters Then
        Convert_Meter_To_Feet offset
        Convert_Meter_To_Feet topo
        Convert_Meter_To_Feet topo1
        Convert_Meter_To_Feet topo2
    ElseIf Not plotInFeet And CSVInFeet Then
        Convert_Feet_To_Meter offset
        Convert_Feet_To_Meter topo
        Convert_Feet_To_Meter topo1
        Convert_Feet_To_Meter topo2
    End If
End Sub

Sub LayerVars_From_LineBuffer ( parLine As String, _
    station As Double, offset As Double, _
    topo As Double, fold0 As Integer, v0 As Double, _
    topo1 As Double, fold1 As Integer, v1 As Double, _
    topo2 As Double, fold2 As Integer, v2 As Double )

    Dim commaCount As Integer
    Count_Commas_In_LineBuffer parLine, commaCount

    topo1 = -1000000
    fold1 = -1
    v1    = -1000000

    topo2 = -1000000
    fold2 = -1
    v2    = -1000000

    If     commaCount = 4 Then
        Input #1, station, offset, topo, fold0, v0
    ElseIf commaCount = 7 Then
        Input #1, station, offset, topo, fold0, v0, topo1, fold1, v1
    ElseIf commaCount = 10 Then
        Input #1, station, offset, topo, fold0, v0, topo1, fold1, v1, _
            topo2, fold2, v2
    End If

    If plotVelocity Then
        topo = v0
        topo1 = v1
        topo2 = v2
    End If
    Convert_Refractor_To_Feet_Or_Meters offset, topo, topo1, topo2

End Sub


Sub AddLayerPoint_ToPolyLine ( layer As Integer, _
    linesInArray As Integer, _
    polyLine() As Double )

    Dim parLine As String
    Dim station As Double
    Dim offset As Double
    Dim topo As Double
    Dim fold0 As Integer
    Dim v0 As Double
    Dim topo1 As Double
    Dim fold1 As Integer
    Dim v1 As Double
    Dim topo2 As Double
    Dim fold2 As Integer
    Dim v2 As Double

    fold0 = -1
    fold1 = -1
    fold2 = -1

    Dim filePos As Long
    filePos = Seek(1)
    Line Input #1, parLine
    Seek #1, filePos

    LayerVars_From_LineBuffer parLine, _
        station, offset, topo, fold0, v0, topo1, fold1, v1, _
        topo2, fold2, v2

    Dim layerTopo As Double
    Dim gotLayerTopo As Boolean
    gotLayerTopo = False

    If     ( layer = 2 ) Then
        layerTopo = topo2
        gotLayerTopo = fold2 >= 0
    ElseIf ( layer = 1 ) Then
        layerTopo = topo1
        gotLayerTopo = fold1 >= 0
    ElseIf ( layer = 0 ) Then
        layerTopo = topo
        gotLayerTopo = fold0 >= 0
    End If
    If     ( gotLayerTopo ) Then
        polyLine(linesInArray*2) = offset
        polyLine(linesInArray*2+1) = layerTopo
        linesInArray = linesInArray + 1
    End If
End Sub

Sub DoubleToRawString ( value As Double, _
    strVal As String, _
    negativeFlag As Boolean )

    Dim intVal As Long
    intVal = value * 100

    If ( intVal < 0 ) Then
        negativeFlag = True
        intVal = -intVal
    Else
        negativeFlag = False
    End If

    strVal = ""
    Dim digit As Integer
    While intVal >= 10
        digit = intVal Mod 10
        intVal = intVal \ 10
        strVal = CStr(digit) + strVal
    Wend
    digit = intVal
    strVal = CStr(digit) + strVal
End Sub

Sub RawNumberStringToFormatted ( strVal As String, _
    negativeFlag As Boolean )

    Dim fractionStr As String
    fractionStr = Right$(strVal, 2)
    Dim fractionLength As Integer
    fractionLength = Len(fractionStr)
    Dim wholeLength As Integer
    wholeLength = Len(strVal) - fractionLength
    If ( wholeLength < 0 ) Then
        wholeLength = 0
    End If
    Dim wholeStr As String
    wholeStr = Left$(strVal, wholeLength)

    If negativeFlag Then
        strVal = "-"
    Else
        strVal = ""
    End If
    strVal = strVal + wholeStr
    If ( wholeLength = 0 ) Then
        strVal = strVal + "0"
    End If
    If ( fractionLength > 0 ) Then
        strVal = strVal + "."
        If ( fractionLength = 1 ) Then
            strVal = strVal + "0"
        End If
        strVal = strVal + fractionStr
    End If
End Sub

Sub DoubleToString ( value As Double, _
    strVal As String )

    Dim negativeFlag As Boolean
    DoubleToRawString value, strVal, negativeFlag

    RawNumberStringToFormatted strVal, negativeFlag
End Sub

Sub Write_LayerPolyLine_ToBLNFile ( linesInArray As Integer, _
    polyLine() As Double )

    Print #2, linesInArray; " "; 1

    Dim doublePos As Double
    Dim doubleVal As Double
    Dim fixedPos As String
    Dim fixedVal As String
    Dim lineNo As Integer

    For lineNo = 0 To linesInArray-1 Step 1
        doublePos = polyLine(lineNo*2)
        doubleVal = polyLine(lineNo*2+1)

        If useOwnNumberFormatting Then
            DoubleTostring doublePos, fixedPos
            DoubleToString doubleVal, fixedVal

            Print #2, fixedPos; " "; fixedVal
        Else
            Print #2, doublePos; " "; doubleVal
        End If
    Next lineNo

    Print #2, "" 'empty line before next polyline
End Sub


Sub Add_LayerPolyLines_ToBLNFile ( layer As Integer )

    Dim linesInArray As Integer
    linesInArray = 0

    While Not EOF(1)
        Dim polyLine(2000) As Double
        While Not EOF(1) And linesInArray < 1000
            AddLayerPoint_ToPolyLine layer, linesInArray, polyLine()
        Wend
        If linesInArray >= 1 Then
           Write_LayerPolyLine_ToBLNFile linesInArray, polyLine()
        End If
        linesInArray = 0
    Wend
End Sub

Sub Skip_ASCIIModel_FileHeader

    Dim headerLine As String
    Line Input #1, layerModelTitle
    headerLine = UCase(layerModelTitle)

    Dim startIndex As Integer
    startIndex = InStr(headerLine, "FEET")
    CSVInFeet = ( startIndex > 0 )

    startIndex = InStr(headerLine, "METER")
    CSVInMeters = ( startIndex > 0 )

    If CSVInFeet And CSVInMeters Then
       CSVInFeet = Not CSVInMeters
    End If

    Line Input #1, headerLine
End Sub

Sub Convert_ASCIIModel_Layer_ToBlnFile ( layer As Integer, _
    LayerBLN_FileName As String, _
    LayerModel_FileName As String )

    Open LayerModel_FileName For Input As #1

    Skip_ASCIIModel_FileHeader

    Add_LayerPolyLines_ToBLNFile layer

    Close #1
End Sub

Sub Convert_ASCIIModel_ToBLNFile ( LayerBLN_FileName As String, _
    LayerModel_FileName As String )

    plotRefractors = False
    plotOverburdenRefractor = plotOverburdenRefractor And ( maxPlot_layer = 2 )

    Open LayerBLN_FileName For Output As #2

    Dim layer As Integer
    If plotTopography Then
        layer = 0
        Convert_ASCIIModel_Layer_ToBlnFile layer, _
            LayerBLN_FileName, LayerModel_FileName
        plotRefractors = True
    End If
    For layer = minPlot_layer To maxPlot_layer Step 1

        Dim doPlotRefractor As Boolean
        doPlotRefractor = ( ( layer = minPlot_layer ) And plotOverburdenRefractor ) Or _
                          ( ( layer = maxPlot_layer ) And plotBaseRefractor )
        If doPlotRefractor Then
            Convert_ASCIIModel_Layer_ToBlnFile layer, _
                LayerBLN_FileName, LayerModel_FileName
            plotRefractors = True
        End If
    Next layer

    Close #2
End Sub


Sub Create_And_Configure_BaseMap ( document As Object, _
    LayerModel_FileName As String, _
    LayerBLN_FileName As String, _
    BaseMapFrame As Object, _
    BaseMap As Object )

    Convert_ASCIIModel_ToBLNFile LayerBLN_FileName, _
        LayerModel_FileName

    If plotRefractors Then
        Set BaseMapFrame = document.Shapes.AddBaseMap(LayerBLN_FileName)
        Set BaseMap = BaseMapFrame.Overlays(1)

        If plotTomogram Then
            BaseMap.Line.ForeColor = srfColorWhite
        Else
            BaseMap.Line.ForeColor = srfColorPink
        End If

        Dim lineWidth As Double
        lineWidth = 0.02
        Convert_Inch_To_Centimeter lineWidth
        BaseMap.Line.Width = lineWidth
    End If
    document.Selection.DeselectAll

End Sub

Sub Setup_HillShading ( imageMap As Object )

    Dim isSurfer13 As Boolean
    Dim isSurfer14 As Boolean
    Dim isSurfer15 As Boolean
    Dim isSurfer13OrLater As Boolean

    isSurfer13 = ( InStr(SurferApp.Version, "13.") = 1 )
    isSurfer14 = ( InStr(SurferApp.Version, "14.") = 1 )
    isSurfer15 = ( InStr(SurferApp.Version, "15.") = 1 )
    isSurfer13OrLater = isSurfer13 Or isSurfer14 Or isSurfer15
    If isSurfer13OrLater Then
        imageMap.HillShading = False
    End If

End Sub

Sub Setup_ImageMap_GeneralTab ( imageMap As Object )
    'Setup General tab, for image map
    imageMap.InterpolatePixels = True
    imageMap.ShowColorScale = True
    imageMap.MissingDataColor = srfColorWhite
End Sub


Sub Create_And_Configure_ImageMap ( document As Object, _
    gridFileName As String, _
    imageMapFrame As Object, _
    imageMap As Object, _
    adaptDataLimits As Boolean, _
    isVelocityPlot As Boolean )

    Set imageMapFrame = document.Shapes.AddImageMap(gridFileName)
    Set imageMap = imageMapFrame.Overlays(1)

    'Setup image map attributes
    Setup_ImageMap_GeneralTab imageMap
    Setup_ColorMap imageMap, adaptDataLimits

    Setup_ImageMap_GeneralTab imageMap
    Setup_ColorScale imageMap, isVelocityPlot:=isVelocityPlot
    Setup_HillShading imageMap

    Setup_ImageMap_GeneralTab imageMap

    document.Selection.DeselectAll

End Sub

Sub Setup_ContourMap_Levels
    'Setup Levels tab, for contour map
    maxZ_Contour = trunc_maxZ
    If ( ( trunc_maxZ - zContour_Interval ) > zContour_Interval ) Then
        maxZ_Contour = trunc_maxZ - zContour_Interval
    End If

    ContourLevels.AutoGenerate(MinLevel:=zContour_Interval, _
        MaxLevel:=maxZ_Contour, _
        Interval:=zContour_Interval)
    ContourLevels.SetLabelFrequency(FirstIndex:=1, _
        NumberToSet:=1, NumberToSkip:=1)

    TomoDoc.Selection.DeselectAll

    For Each ContourLevel In ContourLevels
        Set LevelLine = ContourLevel.Line
        LevelLine.ForeColor = srfColorBlack40
    Next

    TomoDoc.Selection.DeselectAll

End Sub


Sub Create_And_Configure_ContourMap
    Set ContourMapFrame = TomoDoc.Shapes.AddContourMap(TomoGrid)
    Set ContourMap = ContourMapFrame.Overlays(1)
    Set ContourLevels = ContourMap.Levels

    TomoDoc.Selection.DeselectAll

    'Setup contour map attributes
    'Setup General tab, for contour map
    ContourMap.SmoothContours = srfConSmoothMed

    Setup_ContourMap_Levels

End Sub

Sub Setup_Receiver_Symbol ( postMap As Object )

    Dim recvrSize As Double
    If GSCenteredFont Then
        recvrSize = 0.15
    Else
        recvrSize = 0.10
    End If
    Convert_Inch_To_Centimeter recvrSize

    If GSCenteredFont Then
        postMap.BinSymbol(Index:=3).Set = "GS CENTERED"
        postMap.BinSymbol(Index:=3).Index = 48
    Else
        postMap.BinSymbol(Index:=3).Set = "GSI Default Symbols"
        postMap.BinSymbol(Index:=3).Index = 102
    End If
    postMap.BinSymbol(Index:=3).Size = recvrSize
    postMap.BinSymbol(Index:=3).Color = srfColorBlack40

End Sub

Sub Setup_Source_Symbol ( postMap As Object )

    Dim sourceSize As Double
    sourceSize = 0.10
    Convert_Inch_To_Centimeter sourceSize

    postMap.BinSymbol(Index:=2).Set = "GSI Default Symbols"
    postMap.BinSymbol(Index:=2).Index = 21
    postMap.BinSymbol(Index:=2).Size = sourceSize
    postMap.BinSymbol(Index:=2).Color = srfColorRed

End Sub

Sub Setup_Invisible_Symbol ( postMap As Object )

    postMap.BinSymbol(Index:=1).Set = "GSI Default Symbols"
    postMap.BinSymbol(Index:=1).Index = 115
    postMap.BinSymbol(Index:=1).Size = 0.001

End Sub

Sub Create_And_Configure_ShotPostMap ( postMapFrame As Object, _
       postMap As Object )

    Set postMapFrame = TomoDoc.Shapes.AddClassedPostMap(ShotDataFile, 1,2,3,4)
    Set postMap = postMapFrame.Overlays(1)

    postMap.NumClasses = 3

    Setup_Invisible_Symbol postMap:=postMap
    Setup_Source_Symbol postMap:=postMap
    Setup_Receiver_Symbol postMap:=postMap

    Dim Limits(6) As Double
    Limits(0) = 0: Limits(1) = 0.001
    Limits(2) = 1: Limits(3) = 1.001
    Limits(4) = 2: Limits(5) = 2.001
    postMap.SetBinLimits(Limits:=Limits)

    postMap.LabCol = 4
    If boreholeSurvey And Not horizontalHole Then
        postMap.LabelPos = srfPostPosRight
    Else
        postMap.LabelPos = srfPostPosAbove
    End If
End Sub

Sub Overlay_Maps
    If plotTomogram Then
        TomoDoc.Selection.DeselectAll
        TomoMapFrame.Selected = True
        If contourGrid Then
            ContourMapFrame.Selected = True
        End If
    End If
    If ( postShotPoints Or postReceivers ) And Not plotVelocity Then
        ShotPostMapFrame.Selected = True
    End If
    If plotRefractors Then
        BaseMapFrame.Selected = True
    End If

    If plotVelocity Or _
    plotDepth And Not ( postShotPoints Or postReceivers ) Then
        Set OverlayMapFrame = BaseMapFrame
    ElseIf ( Not contourGrid And Not postShotPoints _
         And Not postReceivers And Not plotRefractors ) Then
        Set OverlayMapFrame = TomoMapFrame
    Else
        Set OverlayMapFrame = TomoDoc.Selection.OverlayMaps
    End If

    Setup_MapFrame_Limits_And_Scale(OverlayMapFrame)

    TomoDoc.Selection.DeselectAll
End Sub

Sub Setup_Title_XYCoords_InPageUnits ( document As Object, _
    title As String, _
    xTitle As Double, _
    yTitle As Double )

    Dim PageSetup As Object
    Set PageSetup = document.PageSetup

    If verticalPlotTitle Then
        xTitle = 1.0 - Len(title)/50
        yTitle = 5.5
    ElseIf PageSetup.Orientation = srfLandscape Then
        xTitle = 2.4
        yTitle = 6.55
    Else
        xTitle = 1.0
        yTitle = 7.8
    End If

    Convert_Inch_To_Centimeter xTitle
    Convert_Inch_To_Centimeter yTitle
End Sub

Sub Add_PlotTitle_ToDocument ( document As Object, _
    title As String )

    Dim xTitle As Double
    Dim yTitle As Double

    Setup_Title_XYCoords_InPageUnits document, title, xTitle, yTitle

    Dim TitleText As Object
    Set TitleText = document.Shapes.AddText(x:=xTitle, y:=yTitle, Text:=title)

    If verticalPlotTitle Then
        TitleText.Rotation = -90
    End If

    document.Selection.DeselectAll
End Sub

Sub Add_LayerPolyLines_ToDocument ( document As Object, _
    LayerModel_FileName As String, _
    layerModelLines As Integer )

    document.Shapes.AddBaseMap(LayerModel_FileName)

End Sub

Sub Show_And_Save_Document ( window As Object, _
    document As Object, _
    PlotTitle As String, _
    srfFileName As String )

    'Add title to plot
    Add_PlotTitle_ToDocument document, PlotTitle

    'Zoom to full display size
    window.WindowState = srfWindowStateMaximized
    window.Zoom(srfZoomFitToWindow)

    'Enable ScreenUpdating, AutoRedraw to update the plot window
    SurferApp.ScreenUpdating = True
    window.AutoRedraw = True

    'Save annotated image map to .srf file : SaveAs is not available in free Demo version
    If Not isSrfTrial Then
        document.SaveAs(FileName:=srfFileName)
    End If

End Sub

Sub Signal_StartOfImaging_ToRayfract
    Dim StartString As String

    StartString = "Automatic imaging of the .GRD grid with Surfer has started."
    Open "AUTOTOMO.RUN" For Output As #2
    Write #2, StartString
    Close #2

    Debug.Print "Start flag file AUTOTOMO.RUN written !"

End Sub

Sub Signal_CompletionOfImaging_ToRayfract

    Dim ResultString As String

    'Give Surfer enough time to completely draw and zoom output
    Wait 2 'was 5 until May 1, 2015

    ResultString = "The .GRD grid has been imaged successfully."
    Open End_FlagFile For Output As #1
    Write #1, ResultString
    Close #1

    Debug.Print "End_FlagFile written !"
    Debug.Print ""

End Sub

Sub Lines_In_File ( fileName As String, _
    linesInFile As Integer )

    Dim fileLine As String
    Dim lineLength As Integer
    Dim gotLine As Boolean
    gotLine = True
    linesInFile = 0

    Open fileName For Input As #1

    While Not EOF(1)
        Line Input #1, fileLine
        lineLength = Len(fileLine)
        gotLine = ( lineLength > 0 )
        If gotLine Then
            linesInFile = linesInFile + 1
        End If
    Wend

    Close #1

End Sub

Sub Clone_FileName ( out_name As String, _
   out_ext As String, _
   in_name As String )

   Dim pointIndex As Integer
   pointIndex = InStrRev(in_name, ".")
   out_name = Left(in_name, pointIndex)
   out_name = out_name + "BLN"

End Sub

Sub Init_LayerPlot_Variables()

    If gotLayerPlotFile Then
        Init_Vars_From_LayerPlotFile
    Else
        plotTopography = False
        plotOverburdenRefractor = False
        plotBaseRefractor = False
        plotRefractors = False
        plotDepth = False
        plotVelocity = False
        plotTomogram = True
    End If
    If plotRefractors Then
        Lines_In_File LayerModel_FileName, layerModelLines
        Debug.Print "Lines in layer model file : "; layerModelLines

        Clone_FileName LayerBLN_FileName, ".BLN", LayerModel_FileName
        Debug.Print "LayerBLN_FileName : "; LayerBLN_FileName
        Debug.Print ""
    End If

End Sub


Sub Initialize_Global_Variables()

    Init_Global_Vars

    Init_Vars_From_ParFile
    Init_SrfFileName_From_Grid TomoGrid, TomoSrfFile, True

    If gotCoverageGrid Then
        Init_SrfFileName_From_Grid CoverageGrid, CoverageSrfFile, False
    End If

    Init_LayerPlot_Variables

    Debug.Print "Please wait a few seconds for Surfer..."
End Sub


Sub Convert_Inch_To_Centimeter ( value As Double )

    If convertInchToCentimeter Then
        value = value * 2.54
    End If

End Sub

Sub Detect_Surfer_PageUnits

    Debug.Print ""
    If SurferApp.PageUnits = srfUnitsInch Then
        convertInchToCentimeter = False
    ElseIf SurferApp.PageUnits = srfUnitsCentimeter Then
        convertInchToCentimeter = True
    Else
        convertInchToCentimeter = False
        Debug.Print "SurferApp.PageUnit has invalid value !"
    End If
    Debug.Print "convertInchToCentimeter : "; convertInchToCentimeter
    Debug.Print ""
End Sub

Sub Get_Surfer_Instance_And_Create_Documents()
    'Get existing Surfer instance, or create a new one if none exists
    On Error Resume Next 'Turn off error reporting
    Set SurferApp = GetObject(,"Surfer.Application")
    If Err.Number<>0 Then
        Set SurferApp = CreateObject("Surfer.Application")
    End If
    On Error GoTo 0 'Turn back on error reporting

    SurferApp.Visible = True
    SurferApp.WindowState = srfWindowStateMaximized
    SurferApp.ScreenUpdating = True

    Detect_Surfer_PageUnits

    If plotTomogram And gotCoverageGrid Then
        Create_Document_And_Window CoverageDoc, CoverageWindow
    End If
    Create_Document_And_Window TomoDoc, TomoWindow

    ' Need to first open at least one window so main title _
    ' contains "Demo" string, for free Demo version
    Check_Surfer_Version

End Sub

Sub Get_TrailingSubString ( titleString As String, _
    patternString As String, _
    subString As String )

    Dim stringStart As Integer

    stringStart = InStr(titleString, patternString)
    If stringStart > 0 Then
        subString = Mid(titleString, stringStart)
    Else
        subString = ""
    End If

End Sub

Sub Get_LeadingSubString ( titleString As String, _
    patternString As String, _
    subString As String )

    Dim stringStart As Integer

    stringStart = InStr(titleString, patternString)
    If stringStart > 2 Then
        subString = Left(titleString, stringStart-2)
    Else
        subString = ""
    End If

End Sub

Sub Setup_PlotTitle_ForSectionType()

    Dim versionString As String
    Dim profileString As String
    Dim methodString As String

    'copy version string from end of PlotTitle
    Get_TrailingSubString PlotTitle, "Version", versionString

    'copy profile name from .CSV header, stored in layerModelTitle
    Get_TrailingSubString layerModelTitle, "for profile", profileString

    'copy method name from .CSV header, stored in layerModelTitle
    Get_LeadingSubString layerModelTitle, "Depth Section", methodString

    'rebuild PlotTitle from component strings
    If plotDepth Then
        PlotTitle = methodString + " depth section "
    End If
    If plotVelocity Then
        PlotTitle = methodString + " velocity section "
    End If

    If plotVelocity Or plotDepth Then
        If plotInFeet Then
            PlotTitle = PlotTitle + "in feet "
        Else
            PlotTitle = PlotTitle + "in meters "
        End If
        PlotTitle = PlotTitle + profileString
        PlotTitle = PlotTitle + ", " + versionString
    End If

End Sub

Sub Create_And_Show_And_Save_Maps()
    If plotTomogram And gotCoverageGrid Then
        Create_And_Configure_ImageMap CoverageDoc, CoverageGrid, _
            CoverageMapFrame, CoverageMap, adaptDataLimits:=False, _
            isVelocityPlot:=False
        Setup_MapFrame_Limits_And_Scale CoverageMapFrame
        Show_And_Save_Document CoverageWindow, CoverageDoc, _
            PlotTitle, CoverageSrfFile
    End If
    If plotRefractors Then
        Create_And_Configure_BaseMap TomoDoc, LayerModel_FileName, _
            LayerBLN_FileName, BaseMapFrame, BaseMap
    End If

    If plotTomogram Then
        Create_And_Configure_ImageMap TomoDoc, TomoGrid, _
            TomoMapFrame, TomoMap, adaptDataLimits:=True, _
            isVelocityPlot:=True
        If contourGrid Then
            Create_And_Configure_ContourMap
        End If
    End If

    If ( postShotPoints Or postReceivers ) And Not plotVelocity Then
        Create_And_Configure_ShotPostMap ShotPostMapFrame, _
            ShotPostMap
    End If

    Overlay_Maps

    If gotLayerModelFile And ( CSVInFeet Or CSVInMeters ) Then
        Setup_PlotTitle_ForSectionType
    End If

    Show_And_Save_Document TomoWindow, TomoDoc, _
        PlotTitle, TomoSrfFile

End Sub

Sub Configure_Debugging

    debugScript = False
    Debug.Print ""

End Sub

Sub Main

    Configure_Debugging

    If Not debugScript Then
        Signal_StartOfImaging_ToRayfract
    End If

    Initialize_Global_Variables

    Get_Surfer_Instance_And_Create_Documents

    Create_And_Show_And_Save_Maps

    Signal_CompletionOfImaging_ToRayfract

End Sub
